<?

// почта SMTP
class SendMailSmtpClass {

    public $smtp_username;
    public $smtp_password;
    public $smtp_host;
    public $smtp_from;
    public $smtp_port;
    public $smtp_charset;
	public $boundary;
    public $addFile = false;
    public $multipart;
    
    public function __construct($smtp_username, $smtp_password, $smtp_host, $smtp_port = 25, $smtp_charset = "utf-8") {
        $this->smtp_username = $smtp_username;
        $this->smtp_password = $smtp_password;
        $this->smtp_host = $smtp_host;
        $this->smtp_port = $smtp_port;
        $this->smtp_charset = $smtp_charset;
		
		// разделитель файлов
		$this->boundary = "--".md5(uniqid(time()));
		$this->multipart = "";
    }
    
    function send($mailTo, $subject, $message, $smtp_from) {		
		// подготовка содержимого письма к отправке
		$contentMail = $this->getContentMail($subject, $message, $smtp_from);		
        
        try {
            if(!$socket = @fsockopen($this->smtp_host, $this->smtp_port, $errorNumber, $errorDescription, 30)){
                throw new Exception($errorNumber.".".$errorDescription);
            }
            if (!$this->_parseServer($socket, "220")){
                throw new Exception('Connection error');
            }
			
			$server_name = $_SERVER["SERVER_NAME"];
            fputs($socket, "EHLO $server_name\r\n");
			if(!$this->_parseServer($socket, "250")){
				// если сервер не ответил на EHLO, то отправляем HELO
				fputs($socket, "HELO $server_name\r\n");
				if (!$this->_parseServer($socket, "250")) {				
					fclose($socket);
					throw new Exception('Error of command sending: HELO');
				}				
			}
			
            fputs($socket, "AUTH LOGIN\r\n");
            if (!$this->_parseServer($socket, "334")) {
                fclose($socket);
                throw new Exception('Autorization error');
            }
			
            fputs($socket, base64_encode($this->smtp_username) . "\r\n");
            if (!$this->_parseServer($socket, "334")) {
                fclose($socket);
                throw new Exception('Autorization error');
            }
            
            fputs($socket, base64_encode($this->smtp_password) . "\r\n");
            if (!$this->_parseServer($socket, "235")) {
                fclose($socket);
                throw new Exception('Autorization error');
            }
			
            fputs($socket, "MAIL FROM: <".$this->smtp_username.">\r\n");
            if (!$this->_parseServer($socket, "250")) {
                fclose($socket);
                throw new Exception('Error of command sending: MAIL FROM');
            }
            
			$mailTo = str_replace(" ", "", $mailTo);
			$emails_to_array = explode(',', $mailTo);
			foreach($emails_to_array as $email) {
				fputs($socket, "RCPT TO: <{$email}>\r\n");
				if (!$this->_parseServer($socket, "250")) {
					fclose($socket);
					throw new Exception('Error of command sending: RCPT TO');
				}
			}
			
            fputs($socket, "DATA\r\n");     
            if (!$this->_parseServer($socket, "354")) {
                fclose($socket);
                throw new Exception('Error of command sending: DATA');
            }
            
            fputs($socket, $contentMail."\r\n.\r\n");
            if (!$this->_parseServer($socket, "250")) {
                fclose($socket);
                throw new Exception("E-mail didn't sent");
            }
            
            fputs($socket, "QUIT\r\n");
            fclose($socket);
        } catch (Exception $e) {
            return  $e->getMessage();
        }
        return true;
    }
    
	// парсинг ответа сервера
    private function _parseServer($socket, $response) {
        while (@substr($responseServer, 3, 1) != ' ') {
            if (!($responseServer = fgets($socket, 256))) {
                return false;
            }
        }
        if (!(substr($responseServer, 0, 3) == $response)) {
            return false;
        }
        return true;        
    }
	
	// подготовка содержимого письма
	private function getContentMail($subject, $message, $smtp_from){	
		// если кодировка windows-1251, то перекодируем тему
		if( strtolower($this->smtp_charset) == "windows-1251" ){
			$subject = iconv('utf-8', 'windows-1251', $subject);
		}
        $contentMail = "Date: " . date("D, d M Y H:i:s") . " UT\r\n";
        $contentMail .= 'Subject: =?' . $this->smtp_charset . '?B?'  . base64_encode($subject) . "=?=\r\n";
		
		// заголовок письма
		$headers = "MIME-Version: 1.0\r\n";
		// кодировка письма
		if($this->addFile){
			// если есть файлы
			$headers .= "Content-Type: multipart/mixed; boundary=\"{$this->boundary}\"\r\n"; 
		}else{
			$headers .= "Content-type: text/html; charset={$this->smtp_charset}\r\n"; 			
		}
		$headers .= "From: {$smtp_from[0]} <{$smtp_from[1]}>\r\n"; // от кого письмо
        $contentMail .= $headers . "\r\n";
		
		if($this->addFile){
			// если есть файлы
			$multipart  = "--{$this->boundary}\r\n";   
			$multipart .= "Content-Type: text/html; charset=utf-8\r\n";   
			$multipart .= "Content-Transfer-Encoding: base64\r\n";   
			$multipart .= "\r\n";
			$multipart .= chunk_split(base64_encode($message)); 
			
			// файлы
			$multipart .= $this->multipart; 
			$multipart .= "\r\n--{$this->boundary}--\r\n";
			
			$contentMail .= $multipart;
		}else{
			$contentMail .= $message . "\r\n";
		}
		
		// если кодировка windows-1251, то все письмо перекодируем
		if( strtolower($this->smtp_charset) == "windows-1251" ){
			$contentMail = iconv('utf-8', 'windows-1251', $contentMail);
		}
		
		return $contentMail;
	}
	
}

// Перемешиваем массив
function shuffle_assoc($list) { 
  if (!is_array($list)) return $list; 

  $keys = array_keys($list); 
  shuffle($keys); 
  $random = array(); 
  foreach ($keys as $key) { 
    $random[$key] = $list[$key]; 
  }
  return $random; 
} 

function view_text($source){
$source = stripslashes( $source );
$source = nl2br($source,"html");
return $source;
}

// Округление денег
function p_floor($val, $d){
	return floor($val*pow(10,$d))/pow(10,$d);
}

// Комиссии систем на ввод
function payment_comis_p($src, $summa){
if($src == 2) { $out = ($summa + max( 0.01, round( $summa * 0.5 ) / 100 ));
}elseif($src == 4) { $out= $summa + 0.01; 
}elseif($src == 3) { $out= ($summa + max( 0.01, round( $summa * 1 ) / 100 )); 
}else{ $out = $summa; }
return $out;
}

// Комиссии систем на вывод
function payment_comis_m($src, $summa){
if($src == 1) {
if($summa >= 1.25) { $out = $summa - (($summa * 0.8)/100); }else{ $out = $summa - 0.01; }
}elseif($src == 3) { $out = ($summa - max( 0.01, round( $summa * 0.5 ) / 100 )); 
}elseif($src == 8) { $out = ($summa - (ceil($summa * 2.9 ) / 100)); 
}else{ $out = $summa; }
return $out;
}

// Статусы и рейтинг
function user_status($reyting, $num){
$st_sql = mysql_query("SELECT `id`,`status`,`min_ball`,`max_ball`,`max_vivod`,`serf_mail`,`task`,`coll_out`,`proc`,`max_summ`,`robot` FROM `nano_status` ORDER BY `id` ASC") or die(mysql_error());
while($st_row = mysql_fetch_assoc($st_sql)) {
$id[] = $st_row["id"];
$status[] = $st_row["status"];
$min_ball[] = $st_row["min_ball"];
$max_ball[] = $st_row["max_ball"];
$max_vivod[] = $st_row["max_vivod"];
$serf_mail[] = $st_row["serf_mail"];
$s_task[] = $st_row["task"];
$s_proc[] = $st_row["proc"];
$coll_out[] = $st_row["coll_out"];
$max_summ[] = $st_row["max_summ"];
$r_robot[] = $st_row["robot"];
}
if($reyting <= $max_ball[0]) { if($num == 1){return $status[0];} if($num == 2){return $max_vivod[0];} if($num == 3){return $serf_mail[0];} if($num == 4){return $s_task[0];} if($num == 5){return $coll_out[0];} if($num == 6){return $max_ball[0];} if($num == 7){return $id[0];} if($num == 8){return $min_ball[0];} if($num == 9){return $s_proc[0];} if($num == 10){return $max_summ[0];} if($num == 11){return $r_robot[0];}
}elseif($reyting >= $min_ball[1] AND $reyting < $max_ball[1]){if($num == 1){return $status[1];} if($num == 2){return $max_vivod[1];} if($num == 3){return $serf_mail[1];} if($num == 4){return $s_task[1];} if($num == 5){return $coll_out[1];} if($num == 6){return $max_ball[1];} if($num == 7){return $id[1];} if($num == 8){return $min_ball[1];} if($num == 9){return $s_proc[1];} if($num == 10){return $max_summ[1];} if($num == 11){return $r_robot[1];}
}elseif($reyting >= $min_ball[2] AND $reyting < $max_ball[2]){if($num == 1){return $status[2];} if($num == 2){return $max_vivod[2];} if($num == 3){return $serf_mail[2];} if($num == 4){return $s_task[2];} if($num == 5){return $coll_out[2];} if($num == 6){return $max_ball[2];} if($num == 7){return $id[2];} if($num == 8){return $min_ball[2];} if($num == 9){return $s_proc[2];} if($num == 10){return $max_summ[2];} if($num == 11){return $r_robot[2];}
}elseif($reyting >= $min_ball[3] AND $reyting < $max_ball[3]){if($num == 1){return $status[3];} if($num == 2){return $max_vivod[3];} if($num == 3){return $serf_mail[3];} if($num == 4){return $s_task[3];} if($num == 5){return $coll_out[3];} if($num == 6){return $max_ball[3];} if($num == 7){return $id[3];} if($num == 8){return $min_ball[3];} if($num == 9){return $s_proc[3];} if($num == 10){return $max_summ[3];} if($num == 11){return $r_robot[3];}
}elseif($reyting >= $min_ball[4] AND $reyting < $max_ball[4]){if($num == 1){return $status[4];} if($num == 2){return $max_vivod[4];} if($num == 3){return $serf_mail[4];} if($num == 4){return $s_task[4];} if($num == 5){return $coll_out[4];} if($num == 6){return $max_ball[4];} if($num == 7){return $id[4];} if($num == 8){return $min_ball[4];} if($num == 9){return $s_proc[4];} if($num == 10){return $max_summ[4];} if($num == 11){return $r_robot[4];}
}elseif($reyting > $min_ball[5]){if($num == 1){return $status[5];} if($num == 2){return $max_vivod[5];} if($num == 3){return $serf_mail[5];} if($num == 4){return $s_task[5];} if($num == 5){return $coll_out[5];} if($num == 6){return $max_ball[5];} if($num == 7){return $id[5];} if($num == 8){return $min_ball[5];} if($num == 9){return $s_proc[5];} if($num == 10){return $max_summ[5];} if($num == 11){return $r_robot[5];}
}
}

function ref_ot2($src){
return floor((($src*pow(10,0))/pow(10,0))/12);
}

// Подсчёт % рейтинга
function proc_reyt($max, $min, $ball){
$p_1 = $ball-$min;
$p_2 = $max-$min;
$procc = $p_1*100/$p_2;
return $procc;
}

// Цвет полосок в рейтинге
function cvet($id_ball){
if($id_ball == '1'){$cvet = 'default';}elseif($id_ball == '2'){$cvet = 'primary';}elseif($id_ball == '3'){$cvet = 'info';}else
if($id_ball == '4'){$cvet = 'danger';}elseif($id_ball == '5'){$cvet = 'success';}
return $cvet;
}

//Делаем скриншоты
function screen($url, $razr, $razm, $form, $names)
{
$toapi="http://mini.s-shot.ru/".$razr."/".$razm."/".$form."/?".$url;
$scim = file_get_contents($toapi);
$path = ($_SERVER['DOCUMENT_ROOT'].'/upload/screen');
file_put_contents("$path/".$names.".".$form, $scim);
return $names.".".$form;
}

function is_img_size($width, $height, $urltest) {
$size = getimagesize($urltest);
$w = $size["0"];
$h = $size["1"];
if($w==intval($width) && $h==intval($height)) {
return "true";
}else{
return false;
}
}

function image_valid($type) {
	$file_types  = array(
		'image/pjpeg' => 'jpg',
		'image/jpeg' => 'jpg',
		'image/jpeg' => 'jpeg',
		'image/gif' => 'gif',
		'image/X-PNG' => 'png',
		'image/PNG' => 'png',
		'image/png' => 'png',
		'image/x-png' => 'png',
		'image/JPG' => 'jpg',
		'image/GIF' => 'gif',
		'image/bmp' => 'bmp',
		'image/bmp' => 'BMP'
	);
    
	if(!array_key_exists($type, $file_types)) {
		return "false";
	}else{
		return "true";
	}
}

function is_url_img($urltest) {
	$timeout = 5;
	$curl = curl_init();
	curl_setopt($curl, CURLOPT_URL, $urltest);
	curl_setopt($curl, CURLOPT_USERAGENT, "MySpider/1.0");
	curl_setopt($curl, CURLOPT_HEADER, 1);
	$headers = array("Accept: text/html, text/plain, application/xml", "Accept-Language: ru, ru-RU", "Accept-Charset: windows-1251", "Accept-Encoding: identity", "Connection: close","Cookie: test=5");
	curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	$content = curl_exec($curl);
	$status1 = curl_getinfo($curl, CURLINFO_HTTP_CODE);
	$status2 = curl_getinfo($curl, CURLINFO_CONTENT_TYPE);

	if($status1==200) {
		return "true";
	}elseif($status1==0) {
		return false;
	}elseif($status1==302) {
		return false;
	}else{
		return "true";
	}
}

function p_key($number){
$arr = array('1','2','3','4','5','6','7','8','9');
$key = "";
for($i = 0; $i < $number; $i++){
$index = rand(0, count($arr) - 1);
$key .= $arr[$index];
}
return $key;
}

function smyle_cng($smyle){
$_pattern = array();
$_replace = array();
for($x = 1; $x <= 50; $x++){
$_pattern[] = "[:$x:]";
$_replace[] = '<img class="smile" src="/smiles/'.$x.'.gif" alt="[:'.$x.':]">';
}
$text = str_ireplace($_pattern, $_replace, $smyle);
return $text;
}

function check_email($email) {
if(!preg_match("/^(?:[a-z0-9]+(?:[-_]?[a-z0-9\.\-\_]+)?@[a-z0-9]+(?:\.?[a-z0-9]+)?\.[a-z]{2,5})$/i", substr($email, 0, 50))) { 
    return ''; 
} else {
  return $email;
}
}

function get_us_name($id){
$sql = mysql_query("SELECT `login` FROM `nano_user` WHERE `id`='$id' LIMIT 1");
if(mysql_num_rows($sql) > 0){
return mysql_result($sql,0);
}else{
return "Неизвестный";
}
}

// Вытаскиваем аватар по ID
function get_us_avatar($id){
$sql = mysql_query("SELECT `avatar` FROM `nano_user` WHERE `id`='$id' LIMIT 1");
if(mysql_num_rows($sql) > 0){
return mysql_result($sql,0);
}else{
return "Неизвестный";
}
}

// Определение url профиля
function prof_url($id, $id_login){
if($id == $id_login){
return '';
}else{
return "_".$id;
}
}

function get_newonline($id){
$sql = mysql_query("SELECT `id_user` FROM `nano_online` WHERE `id_user`='$id'") or die(mysql_error());
if(mysql_num_rows($sql) > 0){
return "status-online";
}else{
return "status-offline";
}
}

function get_online($id){
$sql = mysql_query("SELECT `id_user` FROM `nano_online` WHERE `id_user`='$id'") or die(mysql_error());
if(mysql_num_rows($sql) > 0){
return "online";
}else{
return "";
}
}

function online_tab($id){
$sql = mysql_query("SELECT `id_user` FROM `nano_online` WHERE `id_user`='$id'") or die(mysql_error());
if(mysql_num_rows($sql) > 0){
return "#95b75d";
}else{
return "#e04b4a";
}
}

function get_us_id($id){
$sql = mysql_query("SELECT `id` FROM `nano_user` WHERE `login`='$id' LIMIT 1");
if(mysql_num_rows($sql) > 0){
return mysql_result($sql,0);
}else{
return "";
}
}

function check_phone($text){
	$text=str_replace('+','',$text);
	$text=str_replace(' ','',$text);
	$text=str_replace('(','',$text);
	$text=str_replace(')','',$text);
	$text=str_replace('{','',$text);
	$text=str_replace('}','',$text);
	$text=str_replace('|','',$text);
	$text=str_replace('~','',$text);
	$text=str_replace('^','',$text);
	$text=str_replace('<script>','',$text);
	$text=str_replace('</script>','',$text);
	$text=str_replace('document.write','',$text);
	$text=str_replace('none','',$text);
	$text=str_replace('style','',$text);
	$text=str_replace('cookie','',$text);
	$text=str_replace('document.cookie','',$text);
	$text=str_replace('INSERT','',$text);
	$text=str_replace('AND','',$text);
	$text=str_replace('WHERE','',$text);
	$text=str_replace('http','НТТР',$text);
	$text=trim($text);
	return $text;
}

function check_text($text){
	$text=str_replace('`','',$text);
	$text=str_replace('$','',$text);
	$text=str_replace('{','',$text);
	$text=str_replace('}','',$text);
	$text=str_replace('|','',$text);
	$text=str_replace('~','',$text);
	$text=str_replace('^','',$text);
	$text=str_replace('+','',$text);
	$text=str_replace('<script>','',$text);
	$text=str_replace('</script>','',$text);
	$text=str_replace('document.write','',$text);
	$text=str_replace('none','',$text);
	$text=str_replace('style','',$text);
	$text=str_replace('cookie','',$text);
	$text=str_replace('document.cookie','',$text);
	$text=str_replace('INSERT','',$text);
	$text=str_replace('AND','',$text);
	$text=str_replace('WHERE','',$text);
	$text=str_replace('http','НТТР',$text);
	$text=trim($text);
	return $text;
}

function check_task($text){
	$text=str_replace('`','',$text);
	$text=str_replace('$','',$text);
	$text=str_replace('{','',$text);
	$text=str_replace('}','',$text);
	$text=str_replace('|','',$text);
	$text=str_replace('~','',$text);
	$text=str_replace('^','',$text);
	$text=str_replace('+','',$text);
	$text=str_replace('<script>','',$text);
	$text=str_replace('</script>','',$text);
	$text=str_replace('document.write','',$text);
	$text=str_replace('none','',$text);
	$text=str_replace('cookie','',$text);
	$text=str_replace('document.cookie','',$text);
	$text=str_replace('INSERT','',$text);
	$text=str_replace('AND','',$text);
	$text=str_replace('WHERE','',$text);
	$text=trim($text);
	return $text;
}

function check_ip($text){
	$text=str_replace('.','',$text);
	$text=trim($text);
	return $text;
}

function check_text_t($text){
	$text=str_replace('`','',$text);
	$text=str_replace('$','',$text);
	$text=str_replace('{','',$text);
	$text=str_replace('}','',$text);
	$text=str_replace('|','',$text);
	$text=str_replace('~','',$text);
	$text=str_replace('^','',$text);
	$text=str_replace('+','',$text);
	$text=str_replace('<p>','',$text);
	$text=str_replace('</p>','',$text);
	$text=str_replace('http','',$text);
	$text=trim($text);
	return $text;
}

function check_bann($text){
	$text=str_replace('`','',$text);
	$text=str_replace('$','',$text);
	$text=str_replace('{','',$text);
	$text=str_replace('}','',$text);
	$text=str_replace('|','',$text);
	$text=str_replace('~','',$text);
	$text=str_replace('^','',$text);
	$text=str_replace('+','',$text);
	$text=str_replace('<script>','',$text);
	$text=str_replace('</script>','',$text);
	$text=str_replace('document.write','',$text);
	$text=str_replace('none','',$text);
	$text=str_replace('cookie','',$text);
	$text=str_replace('document.cookie','',$text);
	$text=str_replace('INSERT','',$text);
	$text=str_replace('AND','',$text);
	$text=str_replace('WHERE','',$text);
	$text=trim($text);
	return $text;
}

function check_taskk($text){
    $text=str_replace('nbsp;','&nbsp',$text);
	$text=trim($text);
	return $text;
}

function check_tar($text){
	$text=str_replace('&',',',$text);
	$text=str_replace('tar=','',$text);
	$text=trim($text);
	return $text;
}

function getHost($url) {
	$host = str_replace("www.www.","www.", trim($url));
	$host = @parse_url($host);
	$host = trim($host['host'] ? $host['host'] : array_shift(explode('/', $host['path'], 2)));

	if(in_array("www", explode(".", $host))) {
		$just_domain = explode("www.", $host);
		return $just_domain[1];
	}else{
		return $host;
	}
}

function translit($str){
    $alphavit = array(
    "а"=>"a","б"=>"b","в"=>"v","г"=>"g","д"=>"d","е"=>"e",
    "ё"=>"yo","ж"=>"j","з"=>"z","и"=>"i","й"=>"i","к"=>"k","л"=>"l", "м"=>"m",
    "н"=>"n","о"=>"o","п"=>"p","р"=>"r","с"=>"s","т"=>"t",
    "у"=>"y","ф"=>"f","х"=>"h","ц"=>"c","ч"=>"ch", "ш"=>"sh","щ"=>"sh",
    "ы"=>"i","э"=>"e","ю"=>"u","я"=>"ya"," "=>"_",","=>"","."=>"","/"=>"",
	"А"=>"a","Б"=>"b","В"=>"v","Г"=>"g","Д"=>"d","Е"=>"e",
    "Ё"=>"yo","Ж"=>"j","З"=>"z","И"=>"i","Й"=>"i","К"=>"k","Л"=>"l", "М"=>"m",
    "Н"=>"n","О"=>"o","П"=>"p","Р"=>"r","С"=>"s","Т"=>"t",
    "У"=>"y","Ф"=>"f","Х"=>"h","Ц"=>"c","Ч"=>"ch", "Ш"=>"sh","Щ"=>"sh",
    "Ы"=>"i","Э"=>"e","Ю"=>"u","Я"=>"ya","ъ"=>"","ь"=>"",
    );
    return strtr($str, $alphavit);
}

function uc($mensaje){
if (!preg_match("/^[a-zA-Zа-яА-Я0-9\-_]{1,255}$/i", $mensaje)) {
	$mensaje = htmlentities(stripslashes(strtolower(trim($mensaje))));
	$mensaje = str_replace("'"," ",$mensaje);
	$mensaje = str_replace(";"," ",$mensaje);
	$mensaje = str_replace("$"," ",$mensaje);
	return $mensaje;
}else{ return $mensaje; }
}

function valideint($str) {
return (isset($str)) ? filter_var($str, FILTER_VALIDATE_INT) : false;
}
function valideurl($str) {
return (isset($str)) ? filter_var($str) : false;
}
function validefloat($str) {
return (isset($str)) ? filter_var($str, FILTER_VALIDATE_FLOAT) : false;
}
function valideip($str) {
return (isset($str)) ? filter_var($str, FILTER_VALIDATE_IP) : false;
}
function validemail($str) {
return (isset($str)) ? filter_var($str, FILTER_VALIDATE_EMAIL) : false;
}

function getRealIP(){

   if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])){
      $client_ip =
         ( !empty($_SERVER['REMOTE_ADDR']) ) ?
            $_SERVER['REMOTE_ADDR']
            :
            ( ( !empty($_ENV['REMOTE_ADDR']) ) ?
               $_ENV['REMOTE_ADDR']
               :
               "unknown" );
      $entries = explode('[, ]', $_SERVER['HTTP_X_FORWARDED_FOR']);

      reset($entries);
      while (list(, $entry) = each($entries)){
         $entry = trim($entry);
         if ( preg_match("/^([d]{1,3}).([d]{1,3}).([d]{1,3}).([d]{1,3})$/", $entry, $ip_list) ){
            $private_ip = array(
                  '/^0\./',
                  '/^127\.0\.0\.1/',
                  '/^192\.168\..*/',
                  '/^172\.((1[6-9])|(2[0-9])|(3[0-1]))\..*/',
                  '/^10\..*/');

            $found_ip = preg_replace($private_ip, $client_ip, $ip_list[1]);

            if ($client_ip != $found_ip)
            {
               $client_ip = $found_ip;
               break;
            }
         }
      }
   }else{
      $client_ip =
         ( !empty($_SERVER['REMOTE_ADDR']) ) ?
            $_SERVER['REMOTE_ADDR']
            :
            ( ( !empty($_ENV['REMOTE_ADDR']) ) ?
               $_ENV['REMOTE_ADDR']
               :
               "unknown" );
   }

   return $client_ip;

}



// вывод даты 
function date_get($data){
$dates = date("d.m",$data);
$date = date("d.m");
if($date == $dates) {
$date = "Сегодня ";
$date .= date("H:i", $data);
}else{
$date = date("d.m.y", $data);
}
return $date;
}

// дата задания
function date_get_t($data){
$dates = date("d.m",$data);
$date = date("d.m");
if($date == $dates) {
$date = "Сегодня ";
$date .= date("H:i", $data);
}else{
$date = date("d.m.y H:i", $data);
}
return $date;
}

function funk_dr($birthday) {
  $birthday_timestamp = strtotime($birthday);
  $age = date('Y') - date('Y', $birthday_timestamp);
  if (date('md', $birthday_timestamp) > date('md')) {
    $age--;
  }
  return $age;
}

//Фильтрация
function get_post($str) 
    {
        $str = trim($str);
        $str = stripslashes($str);
        $str = htmlspecialchars($str);
        return $str;
    }
?>